Package org.h2.expression.function

# Class FunctionN

java.lang.Object
org.h2.expression.Expression
org.h2.expression.OperationN
org.h2.expression.function.FunctionN

All Implemented Interfaces:
  `ExpressionWithVariableParameters`, `NamedExpression`, `HasSQL`, `Typed`

Direct Known Subclasses:
  `ArrayFunction`, `CoalesceFunction`, `ConcatFunction`, `CryptFunction`, `CSVWriteFunction`, `DataTypeSQLFunction`, `DateTimeFormatFunction`, `DBObjectFunction`, `GCDFunction`, `HashFunction`, `ModeFunction`, `RegexpFunction`, `StringFunction`, `SubstringFunction`, `ToCharFunction`, `TruncateValueFunction`, `XMLFunction`

public abstract class FunctionN extends OperationN implements NamedExpression
Function with many arguments.

## Field Summary

### Fields inherited from class org.h2.expression.OperationN

`args, argsCount, type`

### Fields inherited from class org.h2.expression.Expression

`AUTO_PARENTHESES, MAP_IN_AGGREGATE, MAP_IN_WINDOW, MAP_INITIAL, WITH_PARENTHESES, WITHOUT_PARENTHESES`

### Fields inherited from interface org.h2.util.HasSQL

`ADD_PLAN_INFORMATION, DEFAULT_SQL_FLAGS, NO_CASTS, QUOTE_ONLY_WHEN_REQUIRED, REPLACE_LOBS_FOR_TRACE, TRACE_SQL_FLAGS`

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`FunctionN(Expression[] args)`

## Method Summary

Modifier and Type
Method
Description
`StringBuilder`
`getUnenclosedSQL(StringBuilder builder, int sqlFlags)`
Get the SQL statement of this expression.
`Value`
`getValue(SessionLocal session)`
Return the resulting value for the current row.
`protected Value`
`getValue(SessionLocal session, Value v1, Value v2, Value v3)`
Returns the value of this function.

### Methods inherited from class org.h2.expression.OperationN

`addParameter, doneWithParameters, getCost, getSubexpression, getSubexpressionCount, getType, inlineSubexpressions, isEverything, mapColumns, optimizeArguments, setEvaluatable, updateAggregate`

### Methods inherited from class org.h2.expression.Expression

`addFilterConditions, createIndexConditions, getAlias, getBooleanValue, getColumnName, getColumnNameForView, getEnclosedSQL, getNonAliasExpression, getNotIfPossible, getNullable, getSchemaName, getSQL, getSQL, getSQL, getSQL, getTableAlias, getTableName, getTypeIfStaticallyKnown, getWhenSQL, getWhenValue, isConstant, isIdentity, isNullConstant, isValueSet, isWhenConditionOperand, needParentheses, optimize, optimizeCondition, toString, writeExpressions, writeExpressions`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface org.h2.util.HasSQL

`getTraceSQL`

### Methods inherited from interface org.h2.expression.function.NamedExpression

`getName`

## Constructor Details

### FunctionN

protected FunctionN(Expression[] args)

## Method Details

### getValue

public Value getValue(SessionLocal session)
Description copied from class: `Expression`
Return the resulting value for the current row.

Specified by:
  `getValue` in class `Expression`
Parameters:
  `session` - the session
Returns:
  the result

### getValue

protected Value getValue(SessionLocal session, Value v1, Value v2, Value v3)
Returns the value of this function.

Parameters:
  `session` - the session
  `v1` - the value of first argument, or `null`
  `v2` - the value of second argument, or `null`
  `v3` - the value of third argument, or `null`
Returns:
  the resulting value

### getUnenclosedSQL

public StringBuilder getUnenclosedSQL(StringBuilder builder, int sqlFlags)
Description copied from class: `Expression`
Get the SQL statement of this expression. This may not always be the original SQL statement, especially after optimization. Enclosing '(' and ')' are never appended.

Specified by:
  `getUnenclosedSQL` in class `Expression`
Parameters:
  `builder` - string builder
  `sqlFlags` - formatting flags
Returns:
  the specified string builder